var _a;
// 当前运行环境是否可以使用 dom
export var canUseDom = typeof window !== 'undefined' &&
    typeof document !== 'undefined' &&
    (window === null || window === void 0 ? void 0 : window.document) &&
    ((_a = window.document) === null || _a === void 0 ? void 0 : _a.createElement);
// 插入样式节点缓存
var styleNodeCache = {};
// 插入样式
export var injectStyle = function (css, key, options) {
    var _a, _b;
    if (options === void 0) { options = {}; }
    if (!canUseDom) {
        return null;
    }
    if (styleNodeCache[key]) {
        if (((_a = options.csp) === null || _a === void 0 ? void 0 : _a.nonce) && styleNodeCache[key].nonce !== options.csp.nonce) {
            styleNodeCache[key].nonce = options.csp.nonce;
        }
        if (styleNodeCache[key].innerHTML !== css) {
            styleNodeCache[key].innerHTML = css;
        }
        return styleNodeCache[key];
    }
    var container = document.querySelector('head') || document.body;
    var styleNode = document.createElement('style');
    styleNode.innerHTML = css;
    if ((_b = options.csp) === null || _b === void 0 ? void 0 : _b.nonce) {
        styleNode.nonce = options.csp.nonce;
    }
    if (container.prepend) {
        container.prepend(styleNode);
    }
    else if (container.firstChild) {
        // IE not support `prepend`
        container.insertBefore(styleNode, container.firstChild);
    }
    else {
        container.appendChild(styleNode);
    }
    styleNodeCache[key] = styleNode;
    return styleNode;
};
